
/* (c) COPYRIGHT URI/MIT 1996
   Please read the full copyright statement in the file COPYRIGHT.  

   Authors:
      grf		Glenn Fleirl (glenn@lake.mit.edu)
      jhrg,jimg		James Gallagher (jgallagher@gso.uri.edu)
*/

/* 
   Write whatever is on stdin to the DODS message queue.
*/

/* 
 * $Log: urlqueue.c,v $
 * Revision 1.6.40.1  2000/06/20 20:36:46  jimg
 * Imporved error messages and fixed some doc++ comments (although some
 * problems remain).
 *
 * Revision 1.6  1997/05/01 21:41:40  jimg
 * Added to the error message text displayed when the message queue cannot
 * be opened.
 *
 * Revision 1.5  1997/04/18 22:43:28  jimg
 * Added #include <sys/msg.h> for linix.
 *
 * Revision 1.4  1997/02/06 19:44:21  jimg
 * Added error checks.
 * Used the MAX_QUEUE_LEN constant.
 *
 * Revision 1.3  1996/10/25 23:15:19  jimg
 * Fixed the includes (use unistd.h over sys/types.h).
 *
 * Revision 1.2  1996/10/07 21:12:34  jimg
 * Added Header.
 * Moved queue code to queue.c.
 */

static char id[]={"$Id: urlqueue.c,v 1.6.40.1 2000/06/20 20:36:46 jimg Exp $"};

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/ipc.h>
#include <sys/msg.h>

#include "config_writeval.h"

int
main(int argc, char *argv[])
{
    long queue_id;
    char s[MAX_QUEUE_LEN];
    char *sp = &s[0];
    key_t msgqid = 3075;

    queue_id = queconn(&msgqid);
    if (queue_id < 0) {
	fprintf(stderr, "Could not connect to DODS client program.\n");
	fprintf(stderr, "In order to use this interface to DODS you\n");
	fprintf(stderr, "must have a DODS client running that is waiting\n");
	fprintf(stderr, "to read data. For example see the DODS-Matlab\n");
	fprintf(stderr, "client program named `loaddods'.\n");
	exit(1);
    }

    (void) fgets(s, MAX_QUEUE_LEN, stdin);

    if (strlen(s) >= MAX_QUEUE_LEN-1) {
	fprintf(stderr, 
		"Information passed to DODS client truncated at %d bytes\n", 
		MAX_QUEUE_LEN-1);
    }

    if (strstr(sp, "URL:") == sp) {
	sp += 4;		/* skip leading URL: stuff */
    }

    if (quewrite(queue_id, sp, 10) < 0) {
	fprintf(stderr, "Could not send information to DODS client program\n");
	exit(1);
    }

    exit(0);
}
